// Include the proxy file generate by the soapcpp2 tool
#include "soapAGMS_USCOREAPISoapProxy.h"
// Include the namespace map 
#include "AGMS_USCOREAPISoap.nsmap"

#include <iostream>

using namespace std;

int main(int argc, char const *argv[])
{
	AGMS_USCOREAPISoapProxy service;
	// Initialise request
	_ns1__ProcessTransaction request;
	ns1__Params params;
	// Assign request parameters, note we need to pass address to the class
	std::string GatewayUserName = "your username";
	params.GatewayUserName = &GatewayUserName;
	std::string GatewayPassword = "your password";
	params.GatewayPassword = &GatewayPassword;
	std::string TransactionType = "sale";
	params.TransactionType = &TransactionType;
	std::string PaymentType = "creditcard";
	params.PaymentType = &PaymentType;
	std::string Amount = "1.00";;
	params.Amount = &Amount;
	std::string CCNumber = "4111111111111111";
	params.CCNumber = &CCNumber;
	std::string CCExpDate = "0120";
	params.CCExpDate = &CCExpDate;
	std::string CVV = "123";
	params.CVV = &CVV;

	// Assign params to objparameters
	request.objparameters = &params;

	// Initialised Response
	_ns1__ProcessTransactionResponse response; 

	// Execute the soap call
	int err = service.ProcessTransaction(&request, response);
	if (err == SOAP_OK){
		// Note all response are pointer to string
    	cout << "Status Code: " << *response.ProcessTransactionResult->STATUS_USCORECODE << endl;
    	cout << "Status Message: " << *response.ProcessTransactionResult->STATUS_USCOREMSG << endl;
    	cout << "Status Message: " << *response.ProcessTransactionResult->TRANS_USCOREID << endl;

  	}
  	else {
    	cout << "Error: " << err << endl;
    	service.soap_stream_fault(cout);
    }
	return 0;
}